import java.awt.*;
import java.awt.image.*;
import java.io.*;
import javax.imageio.*;
import javax.swing.*;
import javax.swing.text.*;

/**
 * Eigenes Grafik-Panel
 * 
 * @author Toens
 * @version v0.1
 */
public class JGrafikPanel extends JPanel {
    private BufferedImage srcImage;

    public JGrafikPanel(int width, int height) {
        Rectangle rectBound = this.getBounds();
        // int height = (int) rectBound.getHeight();
        // int width = (int) rectBound.getWidth();
        srcImage = new BufferedImage(width,height,BufferedImage.TYPE_INT_RGB);        
        
        int breite = srcImage.getWidth();
        int hoehe = srcImage.getHeight();
        for(int x = 0; x< breite; x++) {
            for(int y = 0; y<hoehe; y++) {
                // Hintergrundfarbe festlegen:
                int rot = 255;
                int gruen = 255;
                int blau = 255;

                int farbcode = rot*256*256 + gruen*256 + blau;

                // neuen Farbcode an der angegebenen Koordinate setzen
                srcImage.setRGB(x,y,farbcode);
            }
        }

    }

    public static int getFarbcodeFromRGB(int r, int g, int b) {
        return r*256*256 + g*256 + b;
    }
    
    public static int getRFromFarbcode(int farbcode) {
        return (farbcode >> 16);
    }
    
    public static int getGFromFarbcode(int farbcode) {
        return (farbcode >> 8) & (255 << 8);
    }
    
    public static int getBFromFarbcode(int farbcode) {
        return (farbcode) & (((256*256) - 1) << 8);
    }
    
    public void setPixel(int x, int y, boolean setBlackPixel) {
        int farbcode = getFarbcodeFromRGB(255,255,255);
        if (setBlackPixel) {
            farbcode = getFarbcodeFromRGB(0,0,0);
        }
        srcImage.setRGB(x,y,farbcode);
    }
    
  
    public void paintComponent(Graphics g) {
        super.paintComponent(g); // Zur Sicherheit die urspruengliche Methoder der Oberklasse aufrufen
        Graphics2D g2 = (Graphics2D)g;
        g2.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);
        g2.setRenderingHint(RenderingHints.KEY_INTERPOLATION, RenderingHints.VALUE_INTERPOLATION_BILINEAR);

        g.drawImage(srcImage, 0, 0, null);

    }

    public static BufferedImage deepCopy(BufferedImage bi) {
        ColorModel cm = bi.getColorModel();
        boolean isAlphaPremultiplied = cm.isAlphaPremultiplied();
        WritableRaster raster = bi.copyData(bi.getRaster().createCompatibleWritableRaster());
        return new BufferedImage(cm, raster, isAlphaPremultiplied, null);
    }    
}
